#!/usr/bin/perl

use FileHandle;

# Set this to 1 if you don't actually want to send the messages!
my $dryrun = 0;

my $PreviousIsBlank = 0;
my @SoFar;
my @Message;
my $FirstLine = 1;
my $MessageCounter = 0;

my $Recipient = $ARGV[0];
$Recipient =~ s/^.*\///g;
$Recipient .= '@ecs.soton.ac.uk';

print STDERR "Sending messages to $Recipient\n";

while(<>) {
  chomp;
  if (/^From / && $PreviousIsBlank) {
    ProcessMessage(@SoFar);
    undef @SoFar;
    $PreviousIsBlank = 0;
    next;
  }
  push @SoFar, $_ unless $FirstLine;
  $FirstLine = 0;
  $PreviousIsBlank = (/^$/)?1:0;
}

# Process the last message in the file! (if there is one)
ProcessMessage(@SoFar) if @SoFar>3;

exit 0;

sub ProcessMessage {
  my(@Message) = @_;

  # First remove the blank line off the end
  pop @Message;

  foreach (@Message) {
    s/^(From|To|Cc):\s+(.+\@)[a-z-]+\.(ecs\.soton\.ac\.uk.*$)/$1: $2$3/i;
  }

  my $sendmail = new FileHandle;
  $MessageCounter++;
  print "Sending message number $MessageCounter\n";
  print join("\n", grep /^Subject:\s+/, @Message) . "\n";

  return if $dryrun;

  $sendmail->open("|/usr/sbin/sendmail -i -oem $Recipient")
    or die "Cannot run sendmail, $!";
  print $sendmail join("\n", @Message) . "\n";
  $sendmail->close;
}

